/******************************************************/
/* Goblin's Cube - Rubik's cube game for Wii Homebrew */
/* Copyright (C) 2009 Ricardo Bueno Cordeiro          */
/* Licensed under de GNU General Public License v2.0  */
/*   See license_gplv2.txt for detalis                */
/******************************************************/

#ifndef __CONTROL_H_
#define __CONTROL_H_

#include <gccore.h>

#include "sound.h"

#include "control_base.h"
#include "control_game.h"
#include "control_highscore.h"

class Control : public ControlBase {
private:
	ControlGame game;
	ControlHighscore highscore;

	int last_cube_solved_state;

	Sound drop_sound[7];
	u32 random_sound_frame;

	long long solved_time;

public:
	Control();
	
	int update(WPADData *wiimote_data, int state);
	void draw(int state);
	void text(int state);
};

#endif
