/******************************************************/
/* Goblin's Cube - Rubik's cube game for Wii Homebrew */
/* Copyright (C) 2009 Ricardo Bueno Cordeiro          */
/* Licensed under de GNU General Public License v2.0  */
/*   See license_gplv2.txt for detalis                */
/******************************************************/

#ifndef __DRAW_H_
#define __DRAW_H_

#include <gccore.h>
#include <FreeTypeGX.h>

#define FONT_SIZE 32

#define LARGEST_DRAWABLE_TEXT 1024

void DR_getCurrentViewMtx(Mtx m);
void DR_setCurrentViewMtx(Mtx m);
void DR_getCurrentModelMtx(Mtx m);
void DR_setCurrentModelMtx(Mtx m);

void DR_set_cube_texture();
void DR_set_hand_texture();
void DR_set_inst_texture();
void DR_load_textures();

void DR_load_font();

void DR_init(int text_width, int text_height, f32 aspect_ratio);
void DR_configure_text();
void DR_configure_draw();

void DR_draw_text(int x, int y, GXColor c, const char *s, ...);
void DR_draw_text(int x, int y, GXColor c, u16 style, const char *s, ...);

#endif
